]> git.pld-linux.org Git - packages/nfs-utils.git/blobdiff - rpcidmapd.init
- updated pkgconfig_ac patch, dropped now unnecessary BC for libgssglue
[packages/nfs-utils.git] / rpcidmapd.init
index c117b3b3c886141661ab99c66d6ec30902674818..f664b79cd71395b0cf9e7c41ea7dedbc261cbeff 100644 (file)
@@ -1,12 +1,10 @@
-#!/bin/bash
+#!/bin/sh
 #
-# rpcidmapd     Start up and shut down RPC name to UID/GID mapper
+# idmapd       Start up and shut down RPC name to UID/GID mapper
 #
-# Authors:     Chuck Lever <cel@netapp.com>
-#
-# chkconfig: 345 13 82
-# description: Starts user-level daemon for NFSv4 that maps user \
-#              names to UID and GID numbers.
+# chkconfig:   345 12 83
+# description: Starts user-level daemon for NFSv4 that maps user \
+#              names to UID and GID numbers.
 
 # Source function library.
 . /etc/rc.d/init.d/functions
 # Check that networking is up.
 if is_yes "${NETWORKING}"; then
        if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
-               msg_network_down "RPC svcgssd daemon"
+               msg_network_down "RPC idmapd"
                exit 1
        fi
 else
        exit 0
 fi
 
-if [ -x /sbin/pidof ] && [ "$1" != "stop" ]; then
-       [ -z "`/sbin/pidof portmap`" ] && nls "Error: portmap isn't running" && exit 0
+if [ "$1" != "stop" ]; then
+       check_portmapper || { nls "Error: portmap isn't running" && exit 0; }
 fi
 
 # Get service config
@@ -35,47 +33,76 @@ fi
 # /usr may be on NFS, fail silently, nfsfs will start it
 [ -x /usr/sbin/rpc.idmapd ] || exit 0
 
-RETVAL=0
+# Find out what the current runlevel dir is
+RUNLEVELDIR=$(cat /var/run/runlevel.dir)
 
-# See how we were called.
-case "$1" in
-  start)
+start() {
        # Check if the service is already running?
-       if [ ! -f /var/lock/subsys/idmapd ]; then
-               if ! grep -q rpc_pipefs /proc/mounts ; then
-                       modprobe -s sunrpc >/dev/null 2>&1
-                       run_cmd "Mounting /var/lib/nfs/rpc_pipefs filesystem" \
-                               mount -t rpc_pipefs rpc_pipefs /var/lib/nfs/rpc_pipefs
+       if [ -f /var/lock/subsys/idmapd ]; then
+               msg_already_running "RPC idmapd"
+               return
+       fi
+
+       # This is whacko, but we need /proc/fs/nfsd mounted before
+       # starting idmapd on NFS server
+       if [ -e "$RUNLEVELDIR"/S*nfs ]; then
+               if ! grep -q nfsd /proc/mounts ; then
+                       modprobe nfsd > /dev/null 2>&1
+                       run_cmd "Mounting /proc/fs/nfsd filesystem" mount -t nfsd nfsd /proc/fs/nfsd
                fi
+       fi
+       if ! grep -q rpc_pipefs /proc/mounts; then
+               modprobe sunrpc >/dev/null 2>&1
+               run_cmd "Mounting /var/lib/nfs/rpc_pipefs filesystem" \
+                       mount -t rpc_pipefs rpc_pipefs /var/lib/nfs/rpc_pipefs
+       fi
 
-               msg_starting "RPC idmapd"
-               daemon rpc.idmapd $RPCIDMAPOPTIONS
-               RETVAL=$?
-               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/idmapd
-       else
-               msg_already_running "RPC idmapd"
+       msg_starting "RPC idmapd"
+       daemon /usr/sbin/rpc.idmapd $RPCIDMAPOPTIONS
+       RETVAL=$?
+       [ $RETVAL -eq 0 ] && touch /var/lock/subsys/idmapd
+}
+
+stop() {
+       if [ ! -f /var/lock/subsys/idmapd ]; then
+               msg_not_running "RPC idmapd"
+               return
        fi
+
+       msg_stopping "RPC idmapd"
+       killproc rpc.idmapd
+       rm -f /var/lock/subsys/idmapd
+}
+
+# See how we were called.
+RETVAL=0
+case "$1" in
+  start)
+       start
        ;;
   stop)
+       stop
+       ;;
+  restart)
+       stop
+       start
+       ;;
+  reload)
        if [ -f /var/lock/subsys/idmapd ]; then
-               msg_stopping "RPC idmapd"
-               killproc rpc.idmapd
-               rm -f /var/lock/subsys/idmapd
+               msg_reloading "RPC idmapd"
+               killproc rpc.idmapd -HUP
+               RETVAL=$?
        else
                msg_not_running "RPC idmapd"
+               exit 7
        fi
        ;;
   status)
        status rpc.idmapd
        RETVAL=$?
        ;;
-  restart|reload)
-       $0 stop
-       $0 start
-       RETVAL=$?
-       ;;
   *)
-       msg_usage "$0 {start|stop|restart|status}"
+       msg_usage "$0 {start|stop|restart|reload|status}"
        exit 1
 esac
 
This page took 0.036409 seconds and 4 git commands to generate.